Index: src/sdk/cbeditor.cpp
===================================================================
--- src/sdk/cbeditor.cpp	(revision 5236)
+++ src/sdk/cbeditor.cpp	(working copy)
@@ -1761,14 +1761,22 @@
 void cbEditor::GotoLine(int line, bool centerOnScreen)
 {
     cbStyledTextCtrl* control = GetControl();
+
+    // Make sure the line is not folded. This is done before moving to that
+    // line because folding may change the lines layout.
+	control->EnsureVisible(line);
+
+	// If the line following is a fold point it will be unfolded, in this way
+	// when the line is a function declaration the body is shown.
+	DoFoldLine(line+1,0);
+
     if (centerOnScreen)
     {
-        int onScreen = control->LinesOnScreen() >> 1;
+        int onScreen = control->LinesOnScreen() / 2;
         control->GotoLine(line - onScreen);
         control->GotoLine(line + onScreen);
     }
     control->GotoLine(line);
-    UnfoldBlockFromLine(line); // make sure it's visible (not folded)
 }
 
 bool cbEditor::AddBreakpoint(int line, bool notifyDebugger)
